var Db = require('mongodb').Db,
    Connection = require('mongodb').Connection,
    Server = require('mongodb').Server,
    BSON = require('mongodb').BSONNative;

var lr = require('line-reader');

function Csv2Mongo(file, col, map, callback_finish, db, host, port, sep) {
  var map = map.split(',');
  var map_len = map.length;

  var db = new Db(db, new Server(host, port, {}), {native_parser: true});
  
  db.open(function(err, db) {
    db.collection(col, function(err, collection) {  
      lr.eachLine(file, function(line) {
        var col_obj = {};
        var data = line.split(sep);
        for (var i=0; i< map_len; i++) {
        col_obj[map[i]] = data[i];
        }
        collection.insert(col_obj);
      }, function() {
        db.close();
        callback_finish();    
      });
    });
  });
};

function run(file, col, map, callback_finish, db, host, port, sep) {
  var host = host || 'localhost';
  var port = port || Connection.DEFAULT_PORT;
  var sep = sep || '\t';
  Csv2Mongo(file, col, map, callback_finish, db, host, port, sep);
}

exports.run = run;
